unit Client;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, IPNetwork, StdCtrls, FileCtrl, ExtCtrls, ComCtrls;

type
  TfrmClient = class(TForm)
    Panel1: TPanel;
    ClientMessage: TMemo;
    Panel6: TPanel;
    Panel7: TPanel;
    Label2: TLabel;
    Panel8: TPanel;
    ProgressBar1: TProgressBar;
    Panel9: TPanel;
    Panel2: TPanel;
    Label3: TLabel;
    Bevel1: TBevel;
    Panel3: TPanel;
    Label1: TLabel;
    ServerIPList: TMemo;
    Panel4: TPanel;
    DataPanel: TPanel;
		Label5: TLabel;
		Bevel4: TBevel;
		Memo2: TMemo;
		DriveComboBox1: TDriveComboBox;
		DirectoryListBox1: TDirectoryListBox;
		FileListBox1: TFileListBox;
		Panel5: TPanel;
		Bevel3: TBevel;
		SendDataBtn: TBitBtn;
		SendFileBtn: TBitBtn;
		SaveDialog1: TSaveDialog;
		IPClient1: TIPClient;
		ConnectBtn: TSpeedButton;
		Timer1: TTimer;
    Button1: TButton;
		procedure SendFileBtnClick(Sender: TObject);
		procedure SendDataBtnClick(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
		procedure ConnectBtnClick(Sender: TObject);
		procedure IPClient1ClientError(Sender: TObject; IPAddress: string;
			ErrorNo: Integer; ErrorMsg: string);
		procedure IPClient1ClientMessage(Sender: TObject; IPAddress: string;
			MsgNo: Integer; Msg: string);
		procedure IPClient1DataReceived(Sender: TObject; IPAddress: string;
			pData: PChar; Size: Integer);
		procedure IPClient1DataSend(Sender: TObject; IPAddress: String;
			pData: PChar; Size, BlockID, TotalProgress: Integer);
		procedure IPClient1Progress(Sender: TObject; ProgressNo: Integer);
		procedure IPClient1FileReceived(Sender: TObject; Filename,
			IPAddress: string);
		procedure IPClient1FileSend(Sender: TObject; Filename,
			IPAddress: string; TotalProgress: Integer);
    procedure IPClient1ServerClosed(Sender: TObject; IPAddress: string);
    procedure IPClient1ServerConnect(Sender: TObject; IPAddress: string);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure IPClient1InitialiseProgress(Sender: TObject;
      IPAddress: string; TotalProgress: Integer);
    procedure ServerIPListExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	frmClient: TfrmClient;

implementation

{$R *.DFM}

procedure TfrmClient.SendFileBtnClick(Sender: TObject);
var
	a: Integer;
begin
	if FileListBox1.FileName = '' then
		MessageDlg('Select a file to send.', mtError, [mbOK], 0)
	else
	begin
		MessageDlg('IMPORTANT: The destination directory must be the directory'+
			' name for how the server will see it, not how the client will see it.',
			mtInformation, [mbOK], 0);

		SaveDialog1.InitialDir := DirectoryListBox1.Directory;
		SaveDialog1.FileName := FileListBox1.FileName;
		if SaveDialog1.Execute then
			for a:=1 to ServerIPList.Lines.Count do
				if ServerIPList.Lines[a-1] <> '' then
				begin
					ClientMessage.Lines.Add('Posted file transfer to Server: '+
						ServerIPList.Lines[a-1]+' - '+FileListBox1.FileName);
					IPClient1.SendFileToOneServer(ServerIPList.Lines[a-1],
						SaveDialog1.FileName, FileListBox1.FileName);
				end;
	end;
end;

procedure TfrmClient.SendDataBtnClick(Sender: TObject);
var
	sText: String;
begin
	SetLength(sText, Memo2.GetTextLen+1);
	Memo2.GetTextBuf(PChar(sText), Memo2.GetTextLen+1);
	sText[Memo2.GetTextLen] := #0;
	IPClient1.BroadcastDataToAllServers(PChar(sText), Memo2.GetTextLen+1);
end;

procedure TfrmClient.Timer1Timer(Sender: TObject);
begin
	if ConnectBtn.Caption = 'Connect Client' then
		ConnectBtn.Caption := ''
	else
		ConnectBtn.Caption := 'Connect Client';
end;

procedure TfrmClient.ConnectBtnClick(Sender: TObject);
begin
	Timer1.Enabled := False;
	ConnectBtn.Caption := 'Connect Client';
	ServerIPList.Enabled := False;
	IPClient1.ServerIPAddrList.Clear;
	IPClient1.ServerIPAddrList.Assign(ServerIPList.Lines);
	DataPanel.Enabled := True;
	ConnectBtn.Enabled := False;
	ClientMessage.Lines.Add('Establishing connection to server(s).');
	IPClient1.EstablishConnection;
end;

procedure TfrmClient.IPClient1ClientError(Sender: TObject;
	IPAddress: string; ErrorNo: Integer; ErrorMsg: string);
begin
	ClientMessage.Lines.Add('Client ERROR: '+ErrorMsg);
end;

procedure TfrmClient.IPClient1ClientMessage(Sender: TObject;
	IPAddress: string; MsgNo: Integer; Msg: string);
begin
	ClientMessage.Lines.Add('Client Message: '+Msg);
end;

procedure TfrmClient.IPClient1DataReceived(Sender: TObject;
	IPAddress: string; pData: PChar; Size: Integer);
begin
	pData[Size] := #0;
	ClientMessage.Lines.Add('Data Received. ['+IPAddress+'] - '+pData);
end;

procedure TfrmClient.IPClient1DataSend(Sender: TObject; IPAddress: String;
	pData: PChar; Size, BlockID, TotalProgress: Integer);
begin
	ClientMessage.Lines.Add('Data Sent. ['+IPAddress+']');
end;

procedure TfrmClient.IPClient1Progress(Sender: TObject;
	ProgressNo: Integer);
begin
	ProgressBar1.Position := ProgressNo;
end;

procedure TfrmClient.IPClient1FileReceived(Sender: TObject; Filename,
	IPAddress: string);
begin
	ClientMessage.Lines.Add('File received and saved: '+Filename+'. ['+IPAddress+']');
	ProgressBar1.Position := 0;
end;

procedure TfrmClient.IPClient1FileSend(Sender: TObject; Filename,
	IPAddress: string; TotalProgress: Integer);
begin
	ClientMessage.Lines.Add('Sending File: '+Filename+'. ['+IPAddress+']');
	ProgressBar1.Position := 0;
	ProgressBar1.Min := 0;
	ProgressBar1.Max := TotalProgress;
end;

procedure TfrmClient.IPClient1ServerClosed(Sender: TObject;
	IPAddress: string);
begin
	ClientMessage.Lines.Add('A server was closed, will try to reconnect. ['+
		IPAddress+']');
	Button1Click(nil);
end;

procedure TfrmClient.IPClient1ServerConnect(Sender: TObject;
	IPAddress: string);
begin
	ClientMessage.Lines.Add('A server connected. ['+IPAddress+']');
end;

procedure TfrmClient.DirectoryListBox1Change(Sender: TObject);
begin
	FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TfrmClient.IPClient1InitialiseProgress(Sender: TObject;
	IPAddress: string; TotalProgress: Integer);
begin
	ClientMessage.Lines.Add('Receiving File/Data. ['+IPAddress+']');
	ProgressBar1.Position := 0;
	ProgressBar1.Min := 0;
	ProgressBar1.Max := TotalProgress;
end;

procedure TfrmClient.ServerIPListExit(Sender: TObject);
begin
	ChDir(ExtractFilePath(Application.ExeName));
	ServerIPList.Lines.SaveToFile('ServerIPList.DAT');
end;

procedure TfrmClient.FormShow(Sender: TObject);
begin
	ChDir(ExtractFilePath(Application.ExeName));
	if FileExists('ServerIPList.DAT') then
		ServerIPList.Lines.LoadFromFile('ServerIPList.DAT');
end;

procedure TfrmClient.Button1Click(Sender: TObject);
begin
	IPClient1.DisconnectFromAllServers;
	Timer1.Enabled := True;
	ConnectBtn.Caption := 'Connect Client';
	ServerIPList.Enabled := True;
	DataPanel.Enabled := False;
	ConnectBtn.Enabled := True;
	ClientMessage.Lines.Add('Connection to server(s) are/is closed.');
end;

end.
